Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -1,24 +1,26 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
 #include "btrfsioctl.h"
+#include <ntddstor.h>
+#include <ntdddisk.h>
 #ifndef __REACTOS__
-#include <winioctl.h>
+#include <sys/stat.h>
 #endif
 
 #ifndef FSCTL_CSV_CONTROL
@@ -25,36 +27,47 @@
 #define FSCTL_CSV_CONTROL CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 181, METHOD_BUFFERED, FILE_ANY_ACCESS)
 #endif
 
+#ifndef FSCTL_QUERY_VOLUME_CONTAINER_STATE
+#define FSCTL_QUERY_VOLUME_CONTAINER_STATE CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 228, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#endif
+
 #define DOTDOT ".."
 
 #define SEF_AVOID_PRIVILEGE_CHECK 0x08 // on MSDN but not in any header files(?)
 
+#ifndef _MSC_VER // not in mingw yet
+#define DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED 0x80000000
+#endif
+
+#define SEF_SACL_AUTO_INHERIT 0x02
+
 extern LIST_ENTRY VcbList;
 extern ERESOURCE global_loading_lock;
-extern LIST_ENTRY volumes;
-extern ERESOURCE volumes_lock;
+extern PDRIVER_OBJECT drvobj;
 
+static void mark_subvol_dirty(device_extension* Vcb, root* r);
+
 static NTSTATUS get_file_ids(PFILE_OBJECT FileObject, void* data, ULONG length) {
     btrfs_get_file_ids* bgfi;
     fcb* fcb;
-    
+
     if (length < sizeof(btrfs_get_file_ids))
         return STATUS_BUFFER_OVERFLOW;
-    
+
     if (!FileObject)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     bgfi = data;
-    
+
     bgfi->subvol = fcb->subvol->id;
     bgfi->inode = fcb->inode;
     bgfi->top = fcb->Vcb->root_fileref->fcb == fcb ? TRUE : FALSE;
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -61,12 +74,12 @@
 static void get_uuid(BTRFS_UUID* uuid) {
     LARGE_INTEGER seed;
     UINT8 i;
-    
+
     seed = KeQueryPerformanceCounter(NULL);
 
     for (i = 0; i < 16; i+=2) {
         ULONG rand = RtlRandomEx(&seed.LowPart);
-        
+
         uuid->uuid[i] = (rand & 0xff00) >> 8;
         uuid->uuid[i+1] = rand & 0xff;
     }
@@ -75,79 +88,75 @@
 static NTSTATUS snapshot_tree_copy(device_extension* Vcb, UINT64 addr, root* subvol, UINT64* newaddr, PIRP Irp, LIST_ENTRY* rollback) {
     UINT8* buf;
     NTSTATUS Status;
-    write_data_context* wtc;
+    write_data_context wtc;
     LIST_ENTRY* le;
     tree t;
     tree_header* th;
     chunk* c;
-    
+
     buf = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size, ALLOC_TAG);
     if (!buf) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context), ALLOC_TAG);
-    if (!wtc) {
-        ERR("out of memory\n");
-        ExFreePool(buf);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, NULL, Irp, FALSE);
+
+    wtc.parity1 = wtc.parity2 = wtc.scratch = NULL;
+    wtc.mdl = wtc.parity1_mdl = wtc.parity2_mdl = NULL;
+
+    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, NULL, Irp, 0, FALSE, NormalPagePriority);
     if (!NT_SUCCESS(Status)) {
         ERR("read_data returned %08x\n", Status);
         goto end;
     }
-    
+
     th = (tree_header*)buf;
-    
+
     RtlZeroMemory(&t, sizeof(tree));
     t.root = subvol;
     t.header.level = th->level;
     t.header.tree_id = t.root->id;
-    
+
     Status = get_tree_new_address(Vcb, &t, Irp, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("get_tree_new_address returned %08x\n", Status);
         goto end;
     }
-    
+
     if (!t.has_new_address) {
         ERR("tree new address not set\n");
         Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     c = get_chunk_from_address(Vcb, t.new_address);
-            
-    if (c) {
-        increase_chunk_usage(c, Vcb->superblock.node_size);
-    } else {
+
+    if (c)
+        c->used += Vcb->superblock.node_size;
+    else {
         ERR("could not find chunk for address %llx\n", t.new_address);
         Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     th->address = t.new_address;
     th->tree_id = subvol->id;
     th->generation = Vcb->superblock.generation;
     th->fs_uuid = Vcb->superblock.uuid;
-    
+
     if (th->level == 0) {
         UINT32 i;
         leaf_node* ln = (leaf_node*)&th[1];
-        
+
         for (i = 0; i < th->num_items; i++) {
             if (ln[i].key.obj_type == TYPE_EXTENT_DATA && ln[i].size >= sizeof(EXTENT_DATA) && ln[i].offset + ln[i].size <= Vcb->superblock.node_size - sizeof(tree_header)) {
                 EXTENT_DATA* ed = (EXTENT_DATA*)(((UINT8*)&th[1]) + ln[i].offset);
-                
+
                 if ((ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) && ln[i].size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                     EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
-                    
+
                     if (ed2->size != 0) { // not sparse
-                        Status = increase_extent_refcount_data(Vcb, ed2->address, ed2->size, subvol->id, ln[i].key.obj_id, ln[i].key.offset - ed2->offset, 1, Irp, rollback);
-                        
+                        Status = increase_extent_refcount_data(Vcb, ed2->address, ed2->size, subvol->id, ln[i].key.obj_id, ln[i].key.offset - ed2->offset, 1, Irp);
+
                         if (!NT_SUCCESS(Status)) {
                             ERR("increase_extent_refcount_data returned %08x\n", Status);
                             goto end;
@@ -159,13 +168,13 @@
     } else {
         UINT32 i;
         internal_node* in = (internal_node*)&th[1];
-        
+
         for (i = 0; i < th->num_items; i++) {
             TREE_BLOCK_REF tbr;
-            
+
             tbr.offset = subvol->id;
-            
-            Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, NULL, th->level - 1, Irp, rollback);
+
+            Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, NULL, th->level - 1, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("increase_extent_refcount returned %08x\n", Status);
                 goto end;
@@ -172,80 +181,84 @@
             }
         }
     }
-    
+
     *((UINT32*)buf) = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
-    
-    KeInitializeEvent(&wtc->Event, NotificationEvent, FALSE);
-    InitializeListHead(&wtc->stripes);
-    wtc->tree = TRUE;
-    wtc->stripes_left = 0;
-    
-    Status = write_data(Vcb, t.new_address, buf, FALSE, Vcb->superblock.node_size, wtc, NULL, NULL);
+
+    KeInitializeEvent(&wtc.Event, NotificationEvent, FALSE);
+    InitializeListHead(&wtc.stripes);
+    wtc.stripes_left = 0;
+
+    Status = write_data(Vcb, t.new_address, buf, Vcb->superblock.node_size, &wtc, NULL, NULL, FALSE, 0, NormalPagePriority);
     if (!NT_SUCCESS(Status)) {
         ERR("write_data returned %08x\n", Status);
         goto end;
     }
-    
-    if (wtc->stripes.Flink != &wtc->stripes) {
+
+    if (wtc.stripes.Flink != &wtc.stripes) {
+        BOOL need_wait = FALSE;
+
         // launch writes and wait
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+        le = wtc.stripes.Flink;
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
-            if (stripe->status != WriteDataStatus_Ignore)
+
+            if (stripe->status != WriteDataStatus_Ignore) {
+                need_wait = TRUE;
                 IoCallDriver(stripe->device->devobj, stripe->Irp);
-            
+            }
+
             le = le->Flink;
         }
-        
-        KeWaitForSingleObject(&wtc->Event, Executive, KernelMode, FALSE, NULL);
-        
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+
+        if (need_wait)
+            KeWaitForSingleObject(&wtc.Event, Executive, KernelMode, FALSE, NULL);
+
+        le = wtc.stripes.Flink;
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
+
             if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
                 Status = stripe->iosb.Status;
+                log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
-        free_write_data_stripes(wtc);
+
+        free_write_data_stripes(&wtc);
         buf = NULL;
     }
-    
+
     if (NT_SUCCESS(Status))
         *newaddr = t.new_address;
-    
+
 end:
-    ExFreePool(wtc);
-    
+
     if (buf)
         ExFreePool(buf);
-    
+
     return Status;
 }
 
-static void flush_subvol_fcbs(root* subvol, LIST_ENTRY* rollback) {
+void flush_subvol_fcbs(root* subvol) {
     LIST_ENTRY* le = subvol->fcbs.Flink;
-    
+
     if (IsListEmpty(&subvol->fcbs))
         return;
-    
+
     while (le != &subvol->fcbs) {
         struct _fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
         IO_STATUS_BLOCK iosb;
-        
+
         if (fcb->type != BTRFS_TYPE_DIRECTORY && !fcb->deleted)
             CcFlushCache(&fcb->nonpaged->segment_object, NULL, 0, &iosb);
-        
+
         le = le->Flink;
     }
 }
 
-static NTSTATUS do_create_snapshot(device_extension* Vcb, PFILE_OBJECT parent, fcb* subvol_fcb, PANSI_STRING utf8, PUNICODE_STRING name, PIRP Irp) {
+static NTSTATUS do_create_snapshot(device_extension* Vcb, PFILE_OBJECT parent, fcb* subvol_fcb, PANSI_STRING utf8, PUNICODE_STRING name, BOOL readonly, PIRP Irp) {
     LIST_ENTRY rollback;
     UINT64 id;
     NTSTATUS Status;
@@ -252,7 +265,7 @@
     root *r, *subvol = subvol_fcb->subvol;
     KEY searchkey;
     traverse_ptr tp;
-    UINT64 address, dirpos, *root_num;
+    UINT64 address, *root_num;
     LARGE_INTEGER time;
     BTRFS_TIME now;
     fcb* fcb = parent->FsContext;
@@ -260,63 +273,69 @@
     LIST_ENTRY* le;
     file_ref *fileref, *fr;
     dir_child* dc = NULL;
-    
+
     if (!ccb) {
         ERR("error - ccb was NULL\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (!(ccb->access & FILE_ADD_SUBDIRECTORY)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
     fileref = ccb->fileref;
-    
-    InitializeListHead(&rollback);
-    
+
+    if (fileref->fcb == Vcb->dummy_fcb)
+        return STATUS_ACCESS_DENIED;
+
     // flush open files on this subvol
-    
-    flush_subvol_fcbs(subvol, &rollback);
 
+    flush_subvol_fcbs(subvol);
+
     // flush metadata
-    
+
     if (Vcb->need_write)
-        do_write(Vcb, Irp, &rollback);
-    
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
+
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        return Status;
+    }
+
     InitializeListHead(&rollback);
-    
+
     // create new root
-    
+
     id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, TRUE, Vcb->superblock.generation, Irp, &rollback);
-    
+    Status = create_root(Vcb, id, &r, TRUE, Vcb->superblock.generation, Irp);
+
     if (!NT_SUCCESS(Status)) {
         ERR("create_root returned %08x\n", Status);
         goto end;
     }
-    
+
     r->lastinode = subvol->lastinode;
-    
+
     if (!Vcb->uuid_root) {
         root* uuid_root;
-        
+
         TRACE("uuid root doesn't exist, creating it\n");
-        
-        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp, &rollback);
-        
+
+        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp);
+
         if (!NT_SUCCESS(Status)) {
             ERR("create_root returned %08x\n", Status);
             goto end;
         }
-        
+
         Vcb->uuid_root = uuid_root;
     }
-    
+
     root_num = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64), ALLOC_TAG);
     if (!root_num) {
         ERR("out of memory\n");
@@ -323,47 +342,47 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     tp.tree = NULL;
-    
+
     do {
         get_uuid(&r->root_item.uuid);
-        
+
         RtlCopyMemory(&searchkey.obj_id, &r->root_item.uuid, sizeof(UINT64));
         searchkey.obj_type = TYPE_SUBVOL_UUID;
         RtlCopyMemory(&searchkey.offset, &r->root_item.uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
-        
+
         Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
     } while (NT_SUCCESS(Status) && !keycmp(searchkey, tp.item->key));
-    
+
     *root_num = r->id;
-    
-    if (!insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(root_num);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     searchkey.obj_id = r->id;
     searchkey.obj_type = TYPE_ROOT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         goto end;
     }
-    
+
     Status = snapshot_tree_copy(Vcb, subvol->root_item.block_number, r, &address, Irp, &rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("snapshot_tree_copy returned %08x\n", Status);
         goto end;
     }
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     r->root_item.inode.generation = 1;
     r->root_item.inode.st_size = 3;
     r->root_item.inode.st_blocks = subvol->root_item.inode.st_blocks;
@@ -382,158 +401,117 @@
     r->root_item.otransid = Vcb->superblock.generation;
     r->root_item.ctime = subvol->root_item.ctime;
     r->root_item.otime = now;
-    
+
+    if (readonly)
+        r->root_item.flags |= BTRFS_SUBVOL_READONLY;
+
     r->treeholder.address = address;
-    
+
     // FIXME - do we need to copy over the send and receive fields too?
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         ERR("error - could not find ROOT_ITEM for subvol %llx\n", r->id);
         Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     RtlCopyMemory(tp.item->data, &r->root_item, sizeof(ROOT_ITEM));
-    
+
     // update ROOT_ITEM of original subvol
-    
+
     subvol->root_item.last_snapshot_generation = Vcb->superblock.generation;
-    
-    // We also rewrite the top of the old subvolume tree, for some reason
-    searchkey.obj_id = 0;
-    searchkey.obj_type = 0;
-    searchkey.offset = 0;
-    
-    Status = find_item(Vcb, subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    subvol->treeholder.tree->write = TRUE;
-    
+
+    mark_subvol_dirty(Vcb, subvol);
+
     // create fileref for entry in other subvolume
-    
-    fr = create_fileref();
+
+    fr = create_fileref(Vcb);
     if (!fr) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
-    fr->utf8.Length = fr->utf8.MaximumLength = utf8->Length;
-    fr->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, fr->utf8.MaximumLength, ALLOC_TAG);
-    if (!fr->utf8.Buffer) {
-        ERR("out of memory\n");
-        free_fileref(fr);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->utf8.Buffer, utf8->Buffer, utf8->Length);
-    
+
     Status = open_fcb(Vcb, r, r->root_item.objid, BTRFS_TYPE_DIRECTORY, utf8, fcb, &fr->fcb, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("open_fcb returned %08x\n", Status);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         goto end;
     }
-    
-    Status = fcb_get_last_dir_index(fcb, &dirpos, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        free_fileref(fr);
-        goto end;
-    }
-    
-    fr->index = dirpos;
-    
-    fr->filepart.MaximumLength = fr->filepart.Length = name->Length;
-    
-    fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-    if (!fr->filepart.Buffer) {
-        ERR("out of memory\n");
-        free_fileref(fr);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->filepart.Buffer, name->Buffer, name->Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fr);
-        goto end;
-    }
-    
+
     fr->parent = fileref;
-    
-    Status = add_dir_child(fileref->fcb, r->id, TRUE, dirpos, utf8, &fr->filepart, &fr->filepart_uc, BTRFS_TYPE_DIRECTORY, &dc);
+
+    Status = add_dir_child(fileref->fcb, r->id, TRUE, utf8, name, BTRFS_TYPE_DIRECTORY, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
-    
+
     fr->dc = dc;
     dc->fileref = fr;
-    
-    insert_fileref_child(fileref, fr, TRUE);
+
+    ExAcquireResourceExclusiveLite(&fileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&fileref->children, &fr->list_entry);
+    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
+
     increase_fileref_refcount(fileref);
-    
+
     fr->created = TRUE;
     mark_fileref_dirty(fr);
-    
+
     if (fr->fcb->type == BTRFS_TYPE_DIRECTORY)
         fr->fcb->fileref = fr;
-    
-    free_fileref(fr);
 
+    fr->fcb->subvol->parent = fileref->fcb->subvol->id;
+
+    free_fileref(Vcb, fr);
+
     // change fcb's INODE_ITEM
-    
+
     fcb->inode_item.transid = Vcb->superblock.generation;
     fcb->inode_item.sequence++;
     fcb->inode_item.st_size += utf8->Length * 2;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     if (!ccb->user_set_write_time)
         fcb->inode_item.st_mtime = now;
-    
+
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
+
     fcb->subvol->root_item.ctime = now;
     fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
-    
-    send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED);
-    send_notification_fileref(fr->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-    
+
+    send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED, NULL);
+    send_notification_fileref(fr->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
     le = subvol->fcbs.Flink;
     while (le != &subvol->fcbs) {
         struct _fcb* fcb2 = CONTAINING_RECORD(le, struct _fcb, list_entry);
         LIST_ENTRY* le2 = fcb2->extents.Flink;
-        
+
         while (le2 != &fcb2->extents) {
             extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-            
+
             if (!ext->ignore)
                 ext->unique = FALSE;
-            
+
             le2 = le2->Flink;
         }
-        
+
         le = le->Flink;
     }
-    
-    do_write(Vcb, Irp, &rollback);
-    
+
+    Status = do_write(Vcb, Irp);
+
     free_trees(Vcb);
-    
-    Status = STATUS_SUCCESS;
-    
+
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
+
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -545,6 +523,8 @@
     NTSTATUS Status;
     btrfs_create_snapshot* bcs = data;
     fcb* subvol_fcb;
+    HANDLE subvolh;
+    BOOL readonly, posix;
     ANSI_STRING utf8;
     UNICODE_STRING nameus;
     ULONG len;
@@ -551,68 +531,103 @@
     fcb* fcb;
     ccb* ccb;
     file_ref *fileref, *fr2;
-    
-    if (length < offsetof(btrfs_create_snapshot, name))
+
+#if defined(_WIN64)
+    if (IoIs32bitProcess(Irp)) {
+        btrfs_create_snapshot32* bcs32 = data;
+
+        if (length < offsetof(btrfs_create_snapshot32, name))
+            return STATUS_INVALID_PARAMETER;
+
+        if (length < offsetof(btrfs_create_snapshot32, name) + bcs32->namelen)
+            return STATUS_INVALID_PARAMETER;
+
+        subvolh = Handle32ToHandle(bcs32->subvol);
+
+        nameus.Buffer = bcs32->name;
+        nameus.Length = nameus.MaximumLength = bcs32->namelen;
+
+        readonly = bcs32->readonly;
+        posix = bcs32->posix;
+    } else {
+#endif
+        if (length < offsetof(btrfs_create_snapshot, name))
+            return STATUS_INVALID_PARAMETER;
+
+        if (length < offsetof(btrfs_create_snapshot, name) + bcs->namelen)
+            return STATUS_INVALID_PARAMETER;
+
+        subvolh = bcs->subvol;
+
+        nameus.Buffer = bcs->name;
+        nameus.Length = nameus.MaximumLength = bcs->namelen;
+
+        readonly = bcs->readonly;
+        posix = bcs->posix;
+#if defined(_WIN64)
+    }
+#endif
+
+    if (!subvolh)
         return STATUS_INVALID_PARAMETER;
-    
-    if (length < offsetof(btrfs_create_snapshot, name) + bcs->namelen)
-        return STATUS_INVALID_PARAMETER;
-    
-    if (!bcs->subvol)
-        return STATUS_INVALID_PARAMETER;
-    
+
     if (!FileObject || !FileObject->FsContext)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
     ccb = FileObject->FsContext2;
-    
+
     if (!fcb || !ccb || fcb->type != BTRFS_TYPE_DIRECTORY)
         return STATUS_INVALID_PARAMETER;
-    
+
     fileref = ccb->fileref;
-    
+
     if (!fileref) {
         ERR("fileref was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (!(ccb->access & FILE_ADD_SUBDIRECTORY)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
-    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY)
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    if (is_subvol_readonly(fcb->subvol, Irp))
         return STATUS_ACCESS_DENIED;
-    
-    nameus.Buffer = bcs->name;
-    nameus.Length = nameus.MaximumLength = bcs->namelen;
-    
-    if (!is_file_name_valid(&nameus))
+
+    if (!is_file_name_valid(&nameus, posix))
         return STATUS_OBJECT_NAME_INVALID;
-    
+
     utf8.Buffer = NULL;
-    
-    Status = RtlUnicodeToUTF8N(NULL, 0, &len, bcs->name, bcs->namelen);
+
+    Status = RtlUnicodeToUTF8N(NULL, 0, &len, nameus.Buffer, nameus.Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N failed with error %08x\n", Status);
         return Status;
     }
-    
+
     if (len == 0) {
         ERR("RtlUnicodeToUTF8N returned a length of 0\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
-    utf8.MaximumLength = utf8.Length = len;
+
+    if (len > 0xffff) {
+        ERR("len was too long\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    utf8.MaximumLength = utf8.Length = (USHORT)len;
     utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.Length, ALLOC_TAG);
-    
+
     if (!utf8.Buffer) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    Status = RtlUnicodeToUTF8N(utf8.Buffer, len, &len, bcs->name, bcs->namelen);
+
+    Status = RtlUnicodeToUTF8N(utf8.Buffer, len, &len, nameus.Buffer, nameus.Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N failed with error %08x\n", Status);
         goto end2;
@@ -621,116 +636,126 @@
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
 
     // no need for fcb_lock as we have tree_lock exclusively
-    Status = open_fileref(fcb->Vcb, &fr2, &nameus, fileref, FALSE, NULL, NULL, PagedPool, FALSE, Irp);
-    
+    Status = open_fileref(fcb->Vcb, &fr2, &nameus, fileref, FALSE, NULL, NULL, PagedPool, ccb->case_sensitive || posix, Irp);
+
     if (NT_SUCCESS(Status)) {
         if (!fr2->deleted) {
             WARN("file already exists\n");
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
             Status = STATUS_OBJECT_NAME_COLLISION;
             goto end3;
         } else
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
     } else if (!NT_SUCCESS(Status) && Status != STATUS_OBJECT_NAME_NOT_FOUND) {
         ERR("open_fileref returned %08x\n", Status);
         goto end3;
     }
-    
-    Status = ObReferenceObjectByHandle(bcs->subvol, 0, *IoFileObjectType, UserMode, (void**)&subvol_obj, NULL);
+
+    Status = ObReferenceObjectByHandle(subvolh, 0, *IoFileObjectType, Irp->RequestorMode, (void**)&subvol_obj, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("ObReferenceObjectByHandle returned %08x\n", Status);
         goto end3;
     }
-    
+
+    if (subvol_obj->DeviceObject != FileObject->DeviceObject) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
     subvol_fcb = subvol_obj->FsContext;
     if (!subvol_fcb) {
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (subvol_fcb->inode != subvol_fcb->subvol->root_item.objid) {
         WARN("handle inode was %llx, expected %llx\n", subvol_fcb->inode, subvol_fcb->subvol->root_item.objid);
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     ccb = subvol_obj->FsContext2;
-    
+
     if (!ccb) {
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (!(ccb->access & FILE_TRAVERSE)) {
         WARN("insufficient privileges\n");
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
+    if (fcb == Vcb->dummy_fcb) {
+        Status = STATUS_ACCESS_DENIED;
+        goto end;
+    }
+
     // clear unique flag on extents of open files in subvol
     if (!IsListEmpty(&subvol_fcb->subvol->fcbs)) {
         LIST_ENTRY* le = subvol_fcb->subvol->fcbs.Flink;
-        
+
         while (le != &subvol_fcb->subvol->fcbs) {
             struct _fcb* openfcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
             LIST_ENTRY* le2;
-            
+
             le2 = openfcb->extents.Flink;
-            
+
             while (le2 != &openfcb->extents) {
                 extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-                
+
                 ext->unique = FALSE;
-                
+
                 le2 = le2->Flink;
             }
-            
+
             le = le->Flink;
         }
     }
-    
-    Status = do_create_snapshot(Vcb, FileObject, subvol_fcb, &utf8, &nameus, Irp);
-    
+
+    Status = do_create_snapshot(Vcb, FileObject, subvol_fcb, &utf8, &nameus, readonly, Irp);
+
     if (NT_SUCCESS(Status)) {
         file_ref* fr;
 
         Status = open_fileref(Vcb, &fr, &nameus, fileref, FALSE, NULL, NULL, PagedPool, FALSE, Irp);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("open_fileref returned %08x\n", Status);
             Status = STATUS_SUCCESS;
         } else {
-            send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED);
-            free_fileref(fr);
+            send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED, NULL);
+            free_fileref(Vcb, fr);
         }
     }
-    
+
 end:
     ObDereferenceObject(subvol_obj);
-    
+
 end3:
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
 end2:
     ExFreePool(utf8.Buffer);
-    
+
     return Status;
 }
 
-static NTSTATUS create_subvol(device_extension* Vcb, PFILE_OBJECT FileObject, WCHAR* name, ULONG length, PIRP Irp) {
-    fcb *fcb, *rootfcb;
+static NTSTATUS create_subvol(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, PIRP Irp) {
+    btrfs_create_subvol* bcs;
+    fcb *fcb, *rootfcb = NULL;
     ccb* ccb;
     file_ref* fileref;
     NTSTATUS Status;
-    LIST_ENTRY rollback;
     UINT64 id;
-    root* r;
+    root* r = NULL;
     LARGE_INTEGER time;
     BTRFS_TIME now;
-    ULONG len, irsize;
+    ULONG len;
+    UINT16 irsize;
     UNICODE_STRING nameus;
     ANSI_STRING utf8;
-    UINT64 dirpos;
     INODE_REF* ir;
     KEY searchkey;
     traverse_ptr tp;
